unit VBSBuilder;

interface

uses classes, sysutils;


function WriteVBSCopy(TmpFolder, SrcFolder:string; Files, tmpFiles:TStringList):string;
function WriteVBSConvert(TmpFolder, Format:string; Files, ListDELETE:TStringList):string;
function WriteVBSDelete(TmpFolder:string; Files:TStringList):string;
function WriteListeTXT(TmpFolder:string; Files:TStringList):string;
function WriteVBSTFusion(TmpFolder:string; ListTMP, ListENCODE, ListDELETE:TStringList; N1, N2:integer):string;
function GetVBSCmd(fic:string):string;

implementation
uses Main, COmmon;

const
  VBSHeader =
    'On Error Resume Next'+CRLF+
    'Set shell = Wscript.CreateObject("WScript.Shell")'+CRLF+
    'Set fso = CreateObject("Scripting.FileSystemObject")'+CRLF+
    't1 = Now'+CRLF; 
  VBSDoItEnd =
    '  t = Int((100-pct)*(now-t1)*1440/pct)'+CRLF+
    '  WScript.Echo "Pos: " & pct & "%      Trem: " & t & "min"'+CRLF+
    'End Sub';
                                      
//------------------------------------------------------------
function GetVBSCmd(fic:string):string;
begin
  Result := 'cscript.exe //Nologo "'+fic+'"';
end;
//------------------------------------------------------------
function WriteListeTXT(TmpFolder:string; Files:TStringList):string;
var
  txtFile : TextFile;
  i : integer;
  TMP: string;
begin
  TMP := GetDirSlash(TmpFolder);
  Result := TMP+'list.txt';
  AssignFile(txtFile, TMP+'list.txt');
  Rewrite(txtFile);
  for I := 0 to Files.Count - 1 do WriteLn(txtFile, TmpFolder+Files[i]);
  CloseFile(txtFile);
end;
//------------------------------------------------------------
function WriteVBSCopy(TmpFolder, SrcFolder:string; Files, tmpFiles:TStringList):string;
var
  txtFile : TextFile;
  i : integer;
  SRC, TMP, pct, fic : string;
begin
  SRC := GetDirSlash(SrcFolder);
  TMP := GetDirSlash(TmpFolder);
  tmpFiles.Clear;
  Result := GetVBSCmd(TMP+'copy.vbs');
  AssignFile(txtFile, TMP+'copy.vbs');
  Rewrite(txtFile);
  WriteLn(txtFile, VBSHeader+
    'Sub DoIt(pct, src, tmp)'+CRLF+
    '  fso.CopyFile "'+SRC+'" & src, "'+TMP+'" & tmp, True'+CRLF+
    VBSDoItEnd
  );
  for I := 0 to Files.Count - 1 do begin
    pct := Str(Int(100*(i+1)/Files.Count));
    fic := Str(i)+'.'+FileExtension(Files[i]);
    tmpFiles.Add(fic);
    WriteLn(txtFile, 'DoIt '+pct+', "'+Files[i]+'", "'+fic+'"');
  end;
  CloseFile(txtFile);
end;
//------------------------------------------------------------
function WriteVBSDelete(TmpFolder:string; Files:TStringList):string;
var
  txtFile : TextFile;
  i : integer;
  TMP, pct : string;
begin
  TMP := GetDirSlash(TmpFolder);
  Result := GetVBSCmd(TMP+'delete.vbs');
  AssignFile(txtFile, TMP+'delete.vbs');
  Rewrite(txtFile);
  WriteLn(txtFile, VBSHeader+
    'Sub DoIt(pct, tmp)'+CRLF+
    '  fso.DeleteFile "'+TMP+'" & tmp, True'+CRLF+
    VBSDoItEnd
  );
  for I := 0 to Files.Count - 1 do begin
    pct := Str(Int(100*(i+1)/Files.Count));
    WriteLn(txtFile, 'DoIt '+pct+', "'+Files[i]+'"');
  end;
  CloseFile(txtFile);
end;
//------------------------------------------------------------
function WriteVBSConvert(TmpFolder, Format:string; Files, ListDELETE:TStringList):string;
var
  txtFile : TextFile;
  i : integer;
  TMP, pct, ext : string;
begin
  TMP := GetDirSlash(TmpFolder);
  Result := GetVBSCmd(TMP+'convert.vbs');
  AssignFile(txtFile, TMP+'convert.vbs');
  Rewrite(txtFile);
  WriteLn(txtFile, VBSHeader+
    'Sub DoIt(pct, tmp, ext)'+CRLF+
    '  shell.Run '+
          '"""'+frmMain.binConvert+'"" ""'+TMP+'" & tmp & ext & """ '+
          '-resize ""'+Format+'>"" -quality 90% '+
          '-size '+Format+' xc:black +swap -gravity center -composite '+
          '""'+TMP+'" & tmp & ".jpg"""'+
          ', 0, True'+CRLF+ 
    VBSDoItEnd
  );
{  WriteLn(txtFile, VBSHeader+
    'Sub DoIt(pct, tmp, ext)'+CRLF+
    '  shell.Run '+
          '"""'+frmMain.binConvert+'"" ""'+TMP+'" & tmp & ext & """ '+
          '-resize ""'+Format+'>"" -quality 90% '+
          '-size '+Format+' xc:black +swap -gravity center -composite '+
          '""'+TMP+'" & tmp & ".jpg"""'+
          ', 0, True'+CRLF+     
    '  shell.Run '+
          '"""'+frmMain.binMogrify+'"" -colorspace YUV -quality 90% '+
          '""'+TMP+'" & tmp & ".jpg"""'+
          ', 0, True'+CRLF+
    VBSDoItEnd
  );   }
  for I := 0 to Files.Count - 1 do begin
    pct := Str(Int(100*(i+1)/Files.Count));
    ext := FileExtension(Files[i]);
    ListDELETE.Add(Files[i]);
    if LowerCase(ext)<>'jpg' then ListDELETE.Add(BaseName(Files[i], ext)+'jpg');
    WriteLn(txtFile, 'DoIt '+pct+', "'+BaseName(Files[i], '.'+ext)+'", ".'+ext+'"');
    Files[i] := BaseName(Files[i], ext)+'jpg';
  end;                   
  WriteLn(txtFile, 'DoIt 100, "f-o-n-d", ".jpg"');
  CloseFile(txtFile);
end;
//------------------------------------------------------------
function WriteVBSTFusion(TmpFolder:string; ListTMP, ListENCODE, ListDELETE:TStringList; N1, N2:integer):string;
var
  txtFile : TextFile;
  i, j : integer;
  TMP, pct, ext, fic : string;
begin
  TMP := GetDirSlash(TmpFolder);
  Result := GetVBSCmd(TMP+'transition.vbs');
  AssignFile(txtFile, TMP+'transition.vbs');
  Rewrite(txtFile);
  WriteLn(txtFile, VBSHeader+
    'Sub DoIt(pct, tmp1, tmp2, tmp3, val)'+CRLF+
    '  shell.Run '+
          '"""'+frmMain.BinComposite+'"" ""'+TMP+'" & tmp1 & """ '+
          '-dissolve " & val & " '+
          '""'+TMP+'" & tmp2 & """ ""'+TMP+'" & tmp3 & """"'+
          ', 0, True'+CRLF+    
    VBSDoItEnd
  );
  for I := 0 to ListTMP.Count - 2 do begin
    ext := FileExtension(ListTMP[i]);
    for j := 1 to N1 do ListENCODE.Add(ListTMP[i]);
    for j := 1 to N2 do begin
      pct := Str(Int(100*(i*N2+j)/((ListTMP.Count - 1)*N2) ));
      fic := BaseName(ListTMP[i], ext)+Str(j)+'.jpg';
      WriteLn(txtFile,
        'DoIt '+pct+', "'+ListTMP[i]+'", "'+ListTMP[i+1]+'", '+
        '"'+fic+'", '+
        Str(ToInt(100-j*100/(N2+1)))
      );
      ListENCODE.Add(fic);
      ListDELETE.Add(fic);
    end;
  end;
  for j := 1 to N1 do ListENCODE.Add(ListTMP[ListTMP.Count - 1]);
  CloseFile(txtFile);
end;
//------------------------------------------------------------


end.
